/***************************************************************************
                          sms.cpp  -  description
                             -------------------
    begin                : Sun Dec 2 2001
    copyright            : (C) 2001 by tomee
    email                : tomee@cpi.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kadu.h"
extern QArray<userlist> userlist;
extern struct config config;

extern void sigchldHndl (int whatever);

Sms::Sms (unsigned int gsmno,const QString & name = "sms", QDialog* parent) : QDialog (parent, name) {
QGridLayout * grid = new QGridLayout(this,3,4,10,3);

body = new QMultiLineEdit(this);
grid->addMultiCellWidget(body,1,1,0,3);
body->setWordWrap(QMultiLineEdit::WidgetWidth);
QObject::connect(body, SIGNAL( textChanged() ), this, SLOT( updateCounter() ));

recipient = new QLineEdit(this);
grid->addWidget(recipient,0,1);

QComboBox * list = new QComboBox(this);
QObject::connect(list, SIGNAL( activated(const QString&) ), this, SLOT( updateRecipient(const QString &) ));
int i = 0;
	list->insertItem("");
while (i++ < userlist.size()) {
	if (strcmp(userlist[i].mobile,"") != 0)
		list->insertItem(__c2q(userlist[i].nickname));

}
grid->addWidget(list,0,3);

QLabel * recilabel = new QLabel(this);
recilabel->setText(i18n("Recipient"));
grid->addWidget(recilabel,0,0);

b_send = new QPushButton(this);
b_send->setText(i18n("Send"));
grid->addWidget(b_send,3,3);
QObject::connect(b_send, SIGNAL( clicked() ), this, SLOT( sendSms() ));

smslen = new QLabel(this);
smslen->setText("0");
grid->addWidget(smslen,3,0);

this->resize(300,200);
this->setCaption(i18n("Send SMS"));
this->show();

}

void Sms::updateRecipient(const QString & newtext) {
	int i = 0;
	while (i++ < userlist.size()) {
		if (strcmp(newtext.local8Bit(),userlist[i].nickname) == 0)
			break;

		}

	recipient->setText(userlist[i].mobile);
}

int Sms::sendSms(void) {
char cmdline[1024];
int recp;
char * bdy;

recp = atoi(recipient->text().latin1());
bdy = strdup(body->text().local8Bit());

if (strcmp(config.smsapp,"") != 0) {
	b_send->setText(i18n("SENT"));
	b_send->setEnabled(false);
	if (config.smscustomconf)
	snprintf(cmdline, sizeof(cmdline), config.smsconf, config.smsapp, recp, bdy);
	else
	snprintf(cmdline, sizeof(cmdline), "%s %d \"%s\"", config.smsapp, recp, bdy);
} else {
	QMessageBox * msgb = new QMessageBox(this);
	msgb->warning(this, "SMS error", "Sms application was not specified. Visit the configuration section" );
	fprintf(stderr,"KK SMS application NOT specified. Exit.\n");
	return -1;
}

pid_t nasz_pid;
nasz_pid = fork();
if (nasz_pid == 0) {
	system(cmdline);
	exit(0);
	}
else {
	struct sigaction sigact;
	sigact.sa_handler = sigchldHndl;
	sigact.sa_flags = 0;
	sigact.sa_restorer = NULL;
	if (sigaction(SIGCHLD,&sigact,NULL) < 0)
      perror("sigaction");
	}

}

void Sms::updateCounter() {
char len[10];
snprintf(len, sizeof(len), "%d", body->text().length());
smslen->setText(len);

}