/***************************************************************************
                          userbox.cpp  -  description
                             -------------------
    begin                : Sat Mar 9 2002
    copyright            : (C) 2002 by tomee
    email                : tomee@cpi.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kadu.h"

extern QArray<userlist> userlist;

MyListBox::MyListBox ( QWidget * parent=0, const char * name=0, WFlags f=0 ) : QListBox(parent, name),
	QToolTip(viewport()) {

}

void MyListBox::maybeTip(const QPoint &c) {
QListBoxItem* item = static_cast<QListBoxItem*>(itemAt(c));

if(item) {
	QRect r(itemRect(item));
	QString s;

	int i;
	for (i = 0; i < userlist.size(); i++)
		if (userlist[i].uin == UserToUin(item->text().local8Bit()))
			break;

	switch (userlist[i].status) {
		case GG_STATUS_AVAIL:
			s += i18n("<I>Available</I>");
			break;
		case GG_STATUS_BUSY:
			s += i18n("<I>Busy</I>");
			break;
		case GG_STATUS_NOT_AVAIL:
			s += i18n("<I>Not available</I>");
			break;
		case GG_STATUS_INVISIBLE2:
			s += i18n("<I>Invisible</I>");
			break;
		case GG_STATUS_BUSY_DESCR:
			s += i18n("<I>Busy</I>");
			break;
		case GG_STATUS_NOT_AVAIL_DESCR:
			s += i18n("<nobr><I>Not available</I></nobr>");
			break;
		default:
			s += i18n("<I>Unknown status</I>");
			break;
		}

	if (descriptionForUser(item) != -1) {
		s += "<BR><BR>";
		s += i18n("<B>Description:</B><BR>");
		s += QString(*userlist[descriptionForUser(item)].description);

		}
	
	tip(r, s);

	}

}

int MyListBox::descriptionForUser(QListBoxItem * s) {
	int i;
	for (i = 0; i < userlist.size(); i++) {
		if (userlist[i].uin == UserToUin(s->text().local8Bit()))
				break;
		}

	if (userlist[i].description != NULL)
		return i;
	else
		return -1;

	}